unit MyConcreteEntityUnit;

interface

uses
  Aurelius.Mapping.Attributes,
  Aurelius.Types.Nullable,
  MyAbstractEntityUnit;

type
  [Enumeration(TEnumMappingType.emInteger)]
  TSituacaoUsuario = (Regular, Bloqueado);

  [Entity]
  [Automapping]
  [Table('USUARIOS')]
  [Sequence('SEQ_USUARIOS')]
  TUsuario = class(TBusinessObject)
  private
    [Column('NOME', [], 65)]
    FNome: string;
    [Column('EMAIL', [], 260)]
    FEmail: Nullable<string>;
    [Column('SITUACAO', [])]
    FSituacao: TSituacaoUsuario;
  public
    property Nome: string read FNome write FNome;
    property Email: Nullable<string> read FEmail write FEmail;
    property Situacao: TSituacaoUsuario read FSituacao write FSituacao;
  end;

implementation

initialization
  RegisterEntity(TUsuario);

end.
